Dim pl
Dim doc
Dim layer

Set pl = CreateObject("PhotoLine.Application")
Set doc = pl.ActiveDocument

pl.Visible = True

If Not doc Is Nothing Then
	Set layer = doc.ActiveLayer
	' Is the active layer an image without adjustments?
	' 1 is the equivalent of LayerType.LTImage
    If ((Not layer Is Nothing) And (layer.Type = 1) And (layer.AdjustmentsCount = 0)) Then
		Dim	adjustmentLayer
		Dim gradientDic
		
		Set gradientDic = CreateObject("PhotoLine.Dictionary")
		' First 0: GradientType.GTLinear
		gradientDic.Add "Type", 0, "Colors", Array(Array(0, 0, 0), Array(1, 1, 1)), "Stops", Array(0, 1), "Points", Array(0.5, 0, 0.5, 1)
		
		' Create an adjustment layer with the same size and position of
		' the active layer
		Set adjustmentLayer = CreateObject("PhotoLine.Image")
		' First 0: PictureType.PTGray, Size parameter 2: CoordinateSystem.CSLayer
		' Use a gradient dictionary as fill color. Can also be an IPLColor or a color
		' dictionary or an array of samples or a fill value.
		adjustmentLayer.InitPicture 0, layer.Size(2), gradientDic
		' Adjustment layer has the same transformation as the active layer.
		adjustmentLayer.MatrixToPage = layer.MatrixToPage
		' Add an Curves adjustment. You can optionally use a PhotoLine.Dictionary
		' for the adjustment options.
		adjustmentLayer.InsertAdjustment -1, "Type", "Curves", "Contrast", 60, "CurveMain", Array(0, 0, 0.5, 0.6, 1, 1)
		
		layer.Insert adjustmentLayer, -1
    End If
End If
