Dim pl
Dim doc
Dim page
Dim docPath

Set pl = CreateObject("PhotoLine.Application")
Set doc = pl.ActiveDocument

pl.Visible = True

If Not doc Is Nothing Then
	docPath = doc.Path
	'WScript.Echo "Pfad: " & docPath
	If (Len(docPath) > 0) Then
		Dim	filenamePosition
		
		filenamePosition = InStrRev(docPath, "\")
		if (filenamePosition > 1) Then
			docPath = Left(docPath, filenamePosition)
		End If

		For Each page In doc
			ExportChildren page.RootLayer, docPath
		Next
	End If
End If

Sub ExportChildren(layer, docPath)
	Dim child

	ExportLayer layer, docPath

	for each child in layer
		ExportChildren child, docPath
	next
	' "for each" is the easiest way to iterate through the children of a layer.
	' Other ways are:
	' Iterate forward (same order as "for each"):
	' Set child = layer.First	' first child of layer
	' Do While (Not child Is Nothing)
	'    child = child.Next
	' Loop
	' Iterate backward (reverse order of "for each"):
	' Set child = layer.Last	' last child of layer
	' Do While (Not child Is Nothing)
	'    child = child.Previous
	' Loop
End Sub


' this functions exports all layers of a document that has a filename as a layer name
' possible options are:
' a picture size before the filename, for example 75%Test.jpg or 640x480 Text.jpg
' a compression parameter behind the extender, for example test.jpg75%
' there can be several filenames, separated by a ",", for example pic1.png, pic1.jpg, pic1.gif
' VBS counts indexes from 1, 0 is not found
Sub ExportLayer(layer, docPath)
	Dim	layerName
	Dim	name
	Dim	nameSeparatorPos
	Dim	lastNameSeparatorPos
	Dim	dotPos

	If Not layer Is Nothing Then
		
		nameSeparatorPos = 1
		lastNameSeparatorPos = 1
		layerName = layer.Name
	
		Do While (Len(layerName) > 0) And (nameSeparatorPos > 0)
	
'			MsgBox layerName , VBOKOnly , "Ebenenname"
	
			nameSeparatorPos = -1
	
			If (lastNameSeparatorPos < Len(layerName)) Then
				nameSeparatorPos = InStr(lastNameSeparatorPos + 1, layerName, ",")
	
				If (nameSeparatorPos <= 0) Then
					nameSeparatorPos = Len(layerName)
				End If
			End If
		
			name = ""
	
			If (nameSeparatorPos > 0) Then
				name = Mid(layerName, lastNameSeparatorPos, nameSeparatorPos - lastNameSeparatorPos + 1)
				name = Trim(name)
			End If
		
			lastNameSeparatorPos = nameSeparatorPos + 1
			
			If (Len(name) > 0) Then
				dotPos = InStr(name, ".")
				If (dotPos > 0) Then
					Dim	extender
					Dim	filename
					Dim	saveFilename
					Dim	scaling
					Dim	startPos
					Dim	jpegCompression
					Dim	newDoc
					
					Set newDoc = layer.CreateDocument(1)
'					Set newDoc = layer.CreateDocument(PhotoLine.LayerCreateDocumentFlags.LCDInvisible)
		
					extender = Mid(name, dotPos + 1, 3)
					
					If (extender = "jpg") Then
						If (Len(name) > dotPos + 4) Then
							Dim	formatLength
		
							formatLength = Len(name) - dotPos - 3

							jpegCompression = Mid(name, dotPos + 4, formatLength - 1)	'' % hinten weg
							jpegCompression = Trim(jpegCompression)
						End If
					End If
										' There has to be a blank or a % before the filename: 75%Test.jpg or 640x480 Text.jpg
					startPos = InStr(name, " ")
					If (startPos <= 0) Then
						startPos = InStr(name, "%")
					End If

					If (startPos < 0) Or (startPos > dotPos) Then
						startPos = 0
					End If
		
					If (startPos > 0) Then
						Dim	value1
						Dim	value2
						
						value1 = 0
						value2 = 0
						scaling = Mid(name, 1, startPos - 1)
						scaling = Trim(scaling)
						
						If (Right(scaling, 1) = "%") Then
							value1 = CInt(Mid(scaling, 0, startPos))
							value2 = value1
							mode = 2
'							mode = PhotoLine.ScaleMode.SMPercent
							haveToScale = 1
						Else
							Dim	secondValuePos
							Dim	size
							
							size = layer.Size
							secondValuePos = InStr(scaling, "x")
							If (secondValuePos > 0) Then
								Dim	tmp
								tmp = Mid(scaling, 1, secondValuePos - 1)
								value1 = CInt(tmp)
								tmp = Mid(scaling, secondValuePos + 1, Len(scaling) - secondValuePos)
								value2 = CInt(tmp)
'								mode = PhotoLine.ScaleMode.SMNormal
								mode = 0
								haveToScale = 1
							End If
						End If
	
						If (haveToScale) Then
							newDoc.DoOperation "Scale", "Mode", mode, "ValueX", value1, "ValueY", value2
						End If
						startPos = startPos + 1			' Necessary for filename
					End If
					If (startPos = 0) Then
						startPos = 1
					End If
					filename = Mid(name, startPos, dotPos - startPos)
					filename = Trim(filename)
					saveFilename = docPath
					saveFilename = saveFilename + filename
					saveFilename = saveFilename + "."
					saveFilename = saveFilename + extender
'					MsgBox saveFilename , VBOKOnly , "saveFilename"
																' jetzt speichern
					If (extender = "jpg") And (Len(jpegCompression) > 0) Then
						newDoc.SaveAs saveFilename, "Compression", jpegCompression
					Else
						newDoc.SaveAs saveFilename
					End If
					If Not newDoc Is Nothing Then
'						newDoc.Close PhotoLine.CloseOption.CODontSave
						newDoc.Close 1
					End If
				End If
			End If
		Loop
	End If
End Sub
