Dim pl
Dim doc

Set pl = CreateObject("PhotoLine.Application")
Set doc = pl.ActiveDocument

pl.Visible = True
If Not doc Is Nothing Then
	ExecuteOperationWithSelectedLayers doc, "Scale"
End If

Sub ExecuteOperationWithSelectedLayers(doc, operation)
	Dim	layer
	Dim selectedLayers
	
	Set selectedLayers = doc.SelectedLayers
	If selectedLayers.Count > 0 Then
		' If there is only 1 selected layer, execute the operation directly
		If selectedLayers.Count = 1 Then
			selectedLayers(0).DoOperation operation, "ShowDialog", true
		Else
			Dim dialogSettings
			
			Set dialogSettings = selectedLayers(0).ShowOperationDialog(operation)
			If Not dialogSettings Is Nothing Then
				For Each layer In selectedLayers
					layer.DoOperation operation, dialogSettings
				Next
			End If
		End If
	End If
End Sub