Dim pl
Dim doc
Dim layer

Set pl = CreateObject("PhotoLine.Application")
Set doc = pl.ActiveDocument

pl.Visible = True

If Not doc Is Nothing Then
	Set layer = doc.ActiveLayer

    If (Not layer Is Nothing) Then
		Dim	textLayer
		Dim range(1)
		Dim pageNumberAttribute
		Dim paragraphAttribute

		Set pageNumberAttribute = CreateObject("PhotoLine.Dictionary")
		pageNumberAttribute.Add "Type", "PageNumber"

		' 0 is centered alignemt (PhotoLine.ParagraphAlignment.PACenter)
		Set paragraphAttribute = CreateObject("PhotoLine.Dictionary")
		paragraphAttribute.Add "Alignment", 2
		
		Set textLayer = CreateObject("PhotoLine.Text")
		' 0 is the coordinate system of the page (PhotoLine.CoordinateSystem.CSPage)
		textLayer.Origin(0) = layer.Origin(0)
		textLayer.Size(0) = layer.Size(0)
		' Insert page number, the character 0x02 is the "attachment" character. The type
		' of attachment is defined by the "Attachment" attribute. Possible attachment types:
		' "Date", "PageNumber", "PageCount", "DocumentName"
		textLayer.Text = Chr("&H02")
		range(0) = 0
		range(1) = 1
		textLayer.SetAttribute range, "Attachment", pageNumberAttribute
		' Insert "-" before and after page number 
		textLayer.Text(1, 0) = " -"
		textLayer.Text(0, 0) = "- "
		' Set black as color
		range(1) = textLayer.TextLength
		textLayer.SetAttribute range, "Color", Array(0, 0, 0)
		textLayer.SetAttribute range, "Paragraph", paragraphAttribute
		
		layer.Parent.Insert textLayer, layer
    End If
End If
