Dim pl
Dim doc
Dim page
Dim	cmykBlack

cmykBlack = Array(0, 0, 0, 1, 1)

Set pl = CreateObject("PhotoLine.Application")
Set doc = pl.ActiveDocument

pl.ArrayStartIndex = 0
pl.Visible = True
If Not doc Is Nothing Then
	Dim	styles
	' WScript.Echo "Edit Text Styles"
	' Replace RGB black in text styles first
	' True: fetch the paragraph styles
	styles = doc.TextStyles(True)
	If (RemoveRGBBlackFromStyles(styles)) Then
		doc.TextStyles(True) = styles
	End If
	
	' False: fetch the character styles
	styles = doc.TextStyles(False)
	If (RemoveRGBBlackFromStyles(styles)) Then
		doc.TextStyles(False) = styles
	End If

	' WScript.Echo "Edit Text layers"
	' Now replace RGB black in all text layers
	For Each page In doc
		EditChildren(page.RootLayer)
    Next
End If

Sub EditChildren(layer)
	Dim child
	
	EditLayer(layer)

	for each child in layer
		EditChildren(child)
	next
	' "for each" is the easiest way to iterate through the children of a layer.
	' Other ways are:
	' Iterate forward (same order as "for each"):
	' Set child = layer.First	' first child of layer
	' Do While (Not child Is Nothing)
	'    child = child.Next
	' Loop
	' Iterate backward (reverse order of "for each"):
	' Set child = layer.Last	' last child of layer
	' Do While (Not child Is Nothing)
	'    child = child.Previous
	' Loop
End Sub

Sub EditLayer(layer)
	' Is it a text layer? 4: PhotoLine.LayerType.LTText
	if (layer.Type = 4) Then
		Dim textRange
		Dim	endIndex
		Dim	actIndex
		Dim attributesRange
		Dim	attributes
		
		' iterate over all attributes inside the text layer
		' textRange(0): start index of text, textRange(1): number of characters
		textRange = layer.TextRange
		actIndex = textRange(0)
		endIndex = actIndex + textRange(1)
		Do While (actIndex < endIndex)
			'WScript.Echo "Index: " & actIndex
			Set attributes = layer.Attributes(actIndex, attributesRange)
			
			If (RemoveRGBBlackFromAttributes(attributes)) Then
				layer.SetAttributes attributesRange, attributes
			End If
			' continue after the current attributes
			actIndex = attributesRange(0) + attributesRange(1)
		Loop
	End If
End Sub

Function RemoveRGBBlackFromStyles(byRef styles)
	Dim style
	Dim attributes
	Dim	color

	RemoveRGBBlackFromStyles = False
	For Each style In styles
		'WScript.Echo "Style-Typ: " & TypeName(style)
		Set attributes = style("Attributes")
		'WScript.Echo "Attributes-Typ: " & TypeName(attributes)
		If (IsEmpty(attributes)) Then
			'WScript.Echo "No text style attributes"
		Else
			If (RemoveRGBBlackFromAttributes(attributes)) Then
				style("Attributes") = attributes
				RemoveRGBBlackFromStyles = True
			End If
		End If
	Next
End Function

Function RemoveRGBBlackFromAttributes(byRef attributes)
	Dim color
	
	RemoveRGBBlackFromAttributes = False
	
	Set color = attributes("Color")
	If (IsEmpty(color)) Then
		'WScript.Echo "No color"
	Else
		' 1: PhotoLine.ColorMode.RGB
		If (color.Model = 1) Then
			Dim	values
			' Is the color black
			values = color.Values
			If ((values(0) = 0) And (values(1) = 0) And (values(2) = 0)) Then
				' Transfer the alpha value
				cmykBlack(4) = values(3)
				' set color to CMYK black
				color.Model = 2
				color.Values = cmykBlack
				
				attributes("Color") = color
				
				RemoveRGBBlackFromAttributes = True
			End If
		End If
	End If
End Function