Dim pl
Dim doc
Dim page
Dim	cmykBlack

cmykBlack = Array(0, 0, 0, 1, 1)

Set pl = CreateObject("PhotoLine.Application")
Set doc = pl.ActiveDocument

pl.ArrayStartIndex = 0
pl.Visible = True
If Not doc Is Nothing Then
	Dim	styles
	' WScript.Echo "Edit Text Styles"
	' Replace RGB black in text styles first
	' True: fetch the paragraph styles
	styles = doc.TextStyles(True)
	If (RemoveRGBBlackFromStyles(styles)) Then
		doc.TextStyles(True) = styles
	End If
	
	' False: fetch the character styles
	styles = doc.TextStyles(False)
	If (RemoveRGBBlackFromStyles(styles)) Then
		doc.TextStyles(False) = styles
	End If

	' WScript.Echo "Edit Text layers"
	' Now replace RGB black in all text layers
	For Each page In doc
		EditChildren(page.RootLayer)
    Next
End If

Sub EditChildren(layer)
	Dim child
	
	EditLayer(layer)

	for each child in layer
		EditChildren(child)
	next
End Sub

Sub EditLayer(layer)
	' Is it a text layer? 4: PhotoLine.LayerType.LTText
	if (layer.Type = 4) Then
		Dim textRange
		Dim	endIndex
		Dim	actIndex
		Dim attributesRange
		Dim	color
		
		' iterate over all attributes inside the text layer
		' textRange(0): start index of text, textRange(1): number of characters
		textRange = layer.TextRange
		actIndex = textRange(0)
		endIndex = actIndex + textRange(1)
		Do While (actIndex < endIndex)
			' WScript.Echo "Index: " & actIndex
			Set color = layer.Attribute(actIndex, "Color", attributesRange)
			
			If (RemoveRGBBlackFromColor(color)) Then
				layer.SetAttribute attributesRange, "Color", color
			End If
			' continue after the current attributes
			actIndex = attributesRange(0) + attributesRange(1)
		Loop
	End If
End Sub

Function RemoveRGBBlackFromStyles(byRef styles)
	Dim style
	Dim attributes
	Dim	color

	RemoveRGBBlackFromStyles = False
	For Each style In styles
		'WScript.Echo "Style-Typ: " & TypeName(style)
		Set attributes = style("Attributes")
		' WScript.Echo "Attributes-Typ: " & TypeName(attributes)
		If (IsEmpty(attributes)) Then
			'WScript.Echo "No text style attributes"
		Else
			Set color = attributes("Color")
			If (RemoveRGBBlackFromColor(color)) Then
				attributes("Color") = color
				style("Attributes") = attributes
				RemoveRGBBlackFromStyles = True
			End If
		End If
	Next
End Function

Function RemoveRGBBlackFromColor(byRef color)
	RemoveRGBBlackFromAttributes = False
	If (IsEmpty(color) Or (color Is Nothing)) Then
		color = CreateObject("PhotoLine.Color")
		color.Model = 2
		cmykBlack(4) = 1
		color.Values = cmykBlack

		RemoveRGBBlackFromColor = True
	Else
		' 1: PhotoLine.ColorModel.RGB
		If (color.Model = 1) Then
			Dim	values
			' Is the color black
			values = color.Values
			If ((values(0) = 0) And (values(1) = 0) And (values(2) = 0)) Then
				' Transfer the alpha value
				cmykBlack(4) = values(3)
				' set color to CMYK black, 2: PhotoLine.ColorModel.CMYK
				color.Model = 2
				color.Values = cmykBlack
				
				RemoveRGBBlackFromColor = True
			End If
		End If
	End If
End Function