Dim pl
Dim doc
Dim page

Set pl = CreateObject("PhotoLine.Application")
Set doc = pl.ActiveDocument

pl.Visible = True
If Not doc Is Nothing Then
	Dim	vector

	Set vector = doc.ActiveLayer
	' Is the active layer a vector layer?
	If (Not vector Is Nothing) And (vector.Type = 2) Then
		Dim	vectorPath
		Dim	points
		Dim	matrixToCM
		Dim cmFactor
		Dim	stringValue
		
		Set vectorPath = vector.VectorPath
		points = vectorPath.Points
		' calculate conversion factor from document pixels to centimeter.
		' " / doc.Resolution" converts pixels to inch, 2.54 converts inch to centimeters
		cmFactor = 2.54 / doc.Resolution
		' convert vector points to centimeter
		Set matrixToCM = vector.MatrixToPage.Concatenate(pl.GetScaleMatrix(cmFactor, cmFactor))
		points = matrixToCM.TransformPoints(points)
		For Each coor In points
			stringValue = stringValue & CStr(FormatNumber(coor, 2)) & ";"
		Next
		pl.InputBox "Positions", "Positions", stringValue
	Else
		MsgBox("The active layer must be a vector.")
	End If
End If
