#ifndef __CONFIG_H__
#define __CONFIG_H__

/* config file for Lensfun library
   generated by CMake
*/
#define CONF_PACKAGE "lensfun"
#define CONF_VERSION "@VERSION_MAJOR@.@VERSION_MINOR@.@VERSION_MICRO@.@VERSION_BUGFIX@"

#ifdef _MSC_VER
	#define PLATFORM_WINDOWS
#else
	#define PLATFORM_OSX
#endif

#define CMAKE_COMPILER_IS_GNUCC 
#ifdef CMAKE_COMPILER_IS_GNUCC 
#define CONF_COMPILER_GCC 1 
#endif

#if defined(PLATFORM_LINUX)
#define SYSTEM_DB_PATH "${CMAKE_INSTALL_FULL_DATAROOTDIR}/lensfun"
#define SYSTEM_DB_UPDATE_PATH "/${CMAKE_INSTALL_LOCALSTATEDIR}/lib/lensfun-updates"
#elif defined(PLATFORM_WINDOWS)
#define SYSTEM_DB_PATH "${CMAKE_INSTALL_DATAROOTDIR}/lensfun"
#define SYSTEM_DB_UPDATE_PATH "${CMAKE_INSTALL_DATAROOTDIR}/lensfun-updates"
#elif defined(PLATFORM_OSX)
#define SYSTEM_DB_PATH "${CMAKE_INSTALL_FULL_DATAROOTDIR}/lensfun"
#define SYSTEM_DB_UPDATE_PATH "/${CMAKE_INSTALL_LOCALSTATEDIR}/lib/lensfun-updates"
#endif

#ifndef PLATFORM_WINDOWS
//fix path to data works only on *nix systems
//on windows that data dir is relocatable
#define CONF_DATADIR "${CMAKE_INSTALL_FULL_DATAROOTDIR}/lensfun"
#else
#define CONF_DATADIR "${LENSFUN_WINDOWS_DATADIR}"
#endif

#define DATABASE_SUBDIR "version_${LENSFUN_DB_VERSION}"

// add a macro to know we're compiling Lensfun, not a client library
#define CONF_LENSFUN_INTERNAL

#define VECTORIZATION_SSE
#define VECTORIZATION_SSE2

#define HAVE_ENDIAN_H

#ifdef _MSC_VER
#define _USE_MATH_DEFINES
#endif

//#define LENSFUN_GLIB_REQUIREMENT_MACRO "GLIB_VERSION_2_40"
//#define GLIB_VERSION_MIN_REQUIRED      (${LENSFUN_GLIB_REQUIREMENT_MACRO})
#define GLIB_VERSION_MIN_REQUIRED      GLIB_VERSION_2_54

// to avoid usage of API that is not in GLIB_VERSION_MIN_REQUIRED version
// and make it easy to detect when to bump requirements:
#define GLIB_VERSION_MAX_ALLOWED      (GLIB_VERSION_MIN_REQUIRED)


#ifndef PLATFORM_WINDOWS
#define GLIB_CHECK_VERSION(a, b, c)	0
#endif


#ifdef PLATFORM_WINDOWS
//#include "windows/mathconstants.h"
#endif

#define CONF_SYMBOL_VISIBILITY	1

#endif // __CONFIG_H__
